#pragma warning(disable:4786)
#include <list>
#include <cmath>
#include "Function.h"
#include "Spreadsheet.h"
#include "Parser.h"

using namespace std;


Formula::Formula(std::string const &formulaText)
    : mFormulaText(formulaText)
{
}

Formula::~Formula()
{}

Value Formula::evaluate(ICellContainer const *container) const
{
    Parser p;
    Value v = p.evalString(mFormulaText, container);
    return v;
}

std::list<std::string> Formula::getSources() const
{
    std::list<std::string> refs;
    Tokenizer tokenizer(mFormulaText.begin(), mFormulaText.end());
    string token;
    Tokenizer::TokenType type;
    while (tokenizer.getNext(token,type))
    {
        if (type == Tokenizer::CELLREF)
        {
            refs.push_back(token);
        }
    }
    return refs;
}
