#ifndef FUNCTION_H_
#define FUNCTION_H_

// Contains IFunction class and some standard
// implementations of IFunction.

#include <list>
#include "Defs.h"

class Cell;
class ICellContainer;

// Class representing a general formula
// which relies on a parser to evaluate
// its input.
class Formula
{
public:
    Formula(std::string const &formulaText="");
    virtual ~Formula();
    // Default copy ctor/op= OK.

    // Implementation of IFunction:
    virtual Value evaluate(ICellContainer const *container) const;
    virtual std::list<std::string> getSources() const;
    virtual std::string getText() const {return mFormulaText;}
    virtual void setText(std::string const &text) {mFormulaText = text;}
private:
    std::string mFormulaText;
};

#endif
